/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Annotation of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph


Revision 1.48 - (hide annotations) (download)
Wed Nov 17 21:38:35 2004 UTC (19 years, 4 months ago) by jmc
Branch: MAIN
Changes since 1.47: +3 -1 lines
save STDERR.0000 when it's not empty

1 edhill 1.19 #! /usr/bin/env bash
2 edhill 1.1 #
3 jmc 1.48 # $Header: /u/gcmpack/MITgcm/verification/testreport,v 1.47 2004/08/03 02:48:57 edhill Exp $
4 edhill 1.12 # $Name: $
5 edhill 1.1 #
6    
7     usage()
8     {
9     echo
10     echo "Usage: $0 [OPTIONS]"
11     echo
12     echo "where possible OPTIONS are:"
13     echo " (-help|-h) print usage"
14 edhill 1.7 echo " (-mpi) use MPI input files"
15 edhill 1.10 echo " (-ieee|-noieee) if possible, use IEEE compiler flags"
16 edhill 1.41 echo " (DEF=\"-ieee\")"
17 edhill 1.6 echo " (-optfile=|-of=)STRING list of optfiles to use"
18 edhill 1.20 echo " (-a|-addr) STRING list of email recipients"
19 edhill 1.6 echo " (DEF=\"edhill@mitgcm.org\")"
20 edhill 1.20 echo " (-t|-tdir) STRING list of test dirs to use"
21 edhill 1.6 echo " (DEF=\"\" which builds all)"
22 edhill 1.20 echo " (-b|-bash) STRING preferred location of a \"bash\" or"
23     echo " Bourne-compatible \"sh\" shell"
24     echo " (DEF=\"\" for \"bash\")"
25 edhill 1.24 echo " (-adm|-ad) perform an adjoint run"
26 edhill 1.20 echo " (-command) STRING command to run"
27 edhill 1.6 echo " (DEF=\"make output.txt\")"
28 edhill 1.20 echo " (-m|-make) STRING command to use for \"make\""
29 edhill 1.8 echo " (DEF=\"make\")"
30 edhill 1.43 echo " (-j) JOBS use \"make -j JOBS\" for parallel builds"
31 edhill 1.10 echo " (-clean) *ONLY* run \"make CLEAN\""
32     echo " (-quick|-q) same as \"-nogenmake -noclean -nodepend\""
33     echo " (-nogenmake|-ng) skip the genmake stage"
34     echo " (-noclean|-nc) skip the \"make clean\" stage"
35     echo " (-nodepend|-nd) skip the \"make depend\" stage"
36 edhill 1.40 echo " (-deldir|-dd) on success, delete the output directory"
37 edhill 1.6 echo
38     echo "and where STRING follows a whitespace-delimited format"
39     echo "such as:"
40     echo " -t 'exp0 exp2 exp3' "
41     echo " -addr='abc@123.com testing@home.org'"
42 edhill 1.1 echo
43     exit 1
44     }
45    
46     # build the mpack utility
47     build_mpack()
48     {
49 edhill 1.34 printf "building the mpack utility... "
50 edhill 1.1 if test ! -x "$MPACKDIR/mpack" ; then
51     if test ! -d $MPACKDIR ; then
52 edhill 1.20 echo
53 edhill 1.1 echo "Error: can't find \"$MPACKDIR\""
54     echo " are you sure this program is being run in the correct "
55     echo " (that is, \"MITGCM_ROOT\verification\") directory?"
56 edhill 1.20 echo
57     HAVE_MPACK=f
58 edhill 1.1 fi
59 edhill 1.34 printf "building mpack... "
60 edhill 1.26 if test "x$CC" = x ; then
61     export CC=cc
62     fi
63 edhill 1.25 ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
64 edhill 1.1 RETVAL=$?
65     if test "x$RETVAL" != x0 ; then
66     echo
67     echo "Error building the mpack tools at: $MPACK_DIR"
68 edhill 1.20 echo
69     HAVE_MPACK=f
70     else
71 edhill 1.25 rm -f tr_build_mpack.out
72 edhill 1.20 HAVE_MPACK=t
73 edhill 1.1 fi
74 edhill 1.20 else
75     HAVE_MPACK=t
76 edhill 1.1 fi
77     echo "OK"
78     }
79    
80     testoutput_for_prop()
81     {
82 edhill 1.34 # testoutput_for_prop dir s1 label subdir extension
83 edhill 1.1 #
84     # compares files in $dir/$subdir/output.txt and $dir/results/output.txt
85     # using search strings s1 and text label
86    
87     if [ $debug -gt 0 ]; then
88     echo testoutput_for_prop: grep "$2" $1/$4/output.txt 1>&2
89     fi
90     if [ -r $1/$4/output.txt ]; then
91 edhill 1.15 grep "$2" $1/$4/output.txt | sed 's/.*=//' | cat -n > tmp1.txt
92 edhill 1.1 lncnt=`wc -l tmp1.txt | awk '{print $1}' `
93     if [ $lncnt -lt 3 ]; then
94     if [ $verbose -gt 0 ]; then
95     echo Not enough lines of output when searching for "$2" 1>&2
96     fi
97     return 99
98     fi
99     else
100     echo testoutput_for_prop: output.txt from model run was not readable 1>&2
101     return 99
102     fi
103     if [ $debug -gt 0 ]; then
104 edhill 1.34 echo testoutput_for_prop: grep "$2" $1/results/output.txt$5 1>&2
105 edhill 1.1 fi
106 edhill 1.34 grep "$2" $1/results/output.txt$5 | sed 's/.*=//' | cat -n > tmp2.txt
107 edhill 1.1 lncnt=`wc -l tmp2.txt | awk '{print $1}' `
108     if [ $lncnt -lt 3 ]; then
109     if [ $verbose -gt 0 ]; then
110     echo Not enough lines of output when searching for "$2" 1>&2
111     fi
112     return 99
113     fi
114     if [ $debug -gt 0 ]; then
115     echo testoutput_for_prop: join tmp1.txt tmp2.txt 1>&2
116     fi
117     join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt
118     if [ $debug -gt 0 ]; then
119     echo testoutput_for_prop: compare_lines 1>&2
120     fi
121 edhill 1.22 if [ $verbose -gt 1 ]; then
122     cat tmp3.txt 1>&2
123     fi
124     echo "-1" >> tmp3.txt
125 edhill 1.23 # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number
126     cat tmp3.txt | sed -e 's|:||g' > tmp4.txt
127     digits_of_similarity=`./tmp_cmpnum < tmp4.txt`
128 edhill 1.1 if [ $digits_of_similarity -eq 99 ]; then
129     if [ $verbose -gt 0 ]; then
130     echo testoutput_for_prop: No comparison was available for \"$2\" 1>&2
131     fi
132     digits_of_similarity=99
133     else
134     if [ $verbose -gt 0 ]; then
135     echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2
136     fi
137     fi
138 edhill 1.23 rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
139 edhill 1.1
140     return $digits_of_similarity
141     }
142    
143     dashnum()
144     {
145     # dashnum n1 n2 n3 ...
146     #
147     # print numbers using %3i format or "--" if number = 99
148    
149     for num in $@ ; do
150     if [ $num = 99 ]; then
151     printf ' --'
152     else
153     printf '%3i' $num
154     fi
155     done
156     }
157    
158 edhill 1.24 testoutput_ad()
159     {
160     grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $5}' > t05.txt
161     grep $3 $1/$2/output.txt_adm | awk '{print NR " " $5}' > t15.txt
162     grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $6}' > t06.txt
163     grep $3 $1/$2/output.txt_adm | awk '{print NR " " $6}' > t16.txt
164     join t05.txt t15.txt > t5.txt
165     join t06.txt t16.txt > t6.txt
166     echo "-1" >> t5.txt
167     echo "-1" >> t6.txt
168     digits_5=`./tmp_cmpnum < t5.txt`
169     digits_6=`./tmp_cmpnum < t6.txt`
170     dashnum $digits_5 $digits_6
171     rm -f t[01][56].txt t[56].txt
172     }
173    
174 edhill 1.1 testoutput()
175     {
176 edhill 1.34 # testoutput directory subdir extension
177 edhill 1.1 #
178     # test output in "directory"
179 edhill 1.24 if test "x$ADM" = x ; then
180     if [ $debug -gt 0 ]; then
181     echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2
182     fi
183 edhill 1.34 testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2 $3; cg2dres=$?
184 edhill 1.24 if [ $debug -gt 0 ]; then
185     echo testoutput: cg2dres=$cg2dres 1>&2
186     fi
187 edhill 1.34 testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2 $3; tmin=$?
188     testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2 $3; tmax=$?
189     testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2 $3; tmean=$?
190     testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2 $3; tsd=$?
191     testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2 $3; smin=$?
192     testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2 $3; smax=$?
193     testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2 $3; smean=$?
194     testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2 $3; ssd=$?
195     testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2 $3; umin=$?
196     testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2 $3; umax=$?
197     testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2 $3; umean=$?
198     testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2 $3; usd=$?
199     testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2 $3; vmin=$?
200     testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2 $3; vmax=$?
201     testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2 $3; vmean=$?
202     testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2 $3; vsd=$?
203 edhill 1.24 dashnum $cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd \
204     $umin $umax $umean $usd $vmin $vmax $vmean $vsd
205     else
206     testoutput_ad $1 $2 "precision_grdchk_result"
207 edhill 1.1 fi
208     }
209    
210     genmakemodel()
211     {
212     # genmakemodel directory
213 edhill 1.10 if test "x$NOGENMAKE" = xt ; then
214     echo "genmake skipped!"
215     else
216 edhill 1.34 if test "x$BASH" = x ; then
217     GENMAKE2="../../../tools/genmake2"
218     else
219     GENMAKE2="$BASH ../../../tools/genmake2 -bash $BASH"
220     fi
221 edhill 1.10 (
222     cd $1;
223 edhill 1.24 command="$GENMAKE2 -ds -m $MAKE"
224     if test "x$ADM" = x ; then
225     command="$command --mods=../code"
226     else
227     command="$command --mods=../code_ad"
228     command="$command -adof=../../../tools/adjoint_options/adjoint_staf"
229     fi
230 edhill 1.10 if test "x$OPTFILE" != xNONE ; then
231     command="$command --optfile=$OPTFILE"
232     fi
233     if test "x$IEEE" != x ; then
234     command="$command -ieee"
235     fi
236     printf 'genmake ... ' 1>&2
237     $command > make.log 2>&1
238     RETVAL=$?
239 edhill 1.44 # Reduce the size of the testing emails!
240 edhill 1.47 head -100 Makefile > $CDIR/Makefile_head
241 edhill 1.10 if test "x$RETVAL" != x0 ; then
242     tail make.log
243     echo "genmakemodel: genmake failed" 1>&2
244 edhill 1.21 cp genmake_* make.log $CDIR
245 edhill 1.10 return 1
246     else
247 edhill 1.20 echo "successful" 1>&2
248 edhill 1.1 fi
249 edhill 1.10 )
250     fi
251 edhill 1.1 }
252    
253     makeclean()
254     {
255     # makeclean directory
256 edhill 1.10 if test "x$NOCLEAN" = xt ; then
257     echo "make CLEAN skipped!"
258     else
259     (
260     cd $1;
261     if test -e output.txt ; then
262     rm -f output.txt
263     fi
264     printf 'make CLEAN ... ' 2>&1
265     if test -r Makefile ; then
266     $MAKE CLEAN >> make.log 2>&1
267     RETVAL=$?
268     if test "x$RETVAL" != x0 ; then
269     tail make.log
270     echo "makeclean: \"make CLEAN\" failed" 1>&2
271     cp make.log $CDIR"/make.log"
272     return 1
273     fi
274     fi
275 edhill 1.20 echo successful 1>&2
276 edhill 1.10 exit 0
277     )
278     fi
279     }
280    
281     makedependmodel()
282     {
283     # makedependmodel directory
284     if test "x$NODEPEND" = xt ; then
285     echo "make depend skipped!"
286     else
287     (
288     cd $1;
289     printf 'make depend ... ' 1>&2
290     $MAKE depend >> make.log 2>&1
291 edhill 1.1 RETVAL=$?
292     if test "x$RETVAL" != x0 ; then
293     tail make.log
294 edhill 1.10 echo "makedependmodel: make depend failed" 1>&2
295 edhill 1.1 cp make.log $CDIR"/make.log"
296     return 1
297 edhill 1.10 else
298 edhill 1.20 echo successful 1>&2
299 edhill 1.1 fi
300 edhill 1.10 )
301     fi
302 edhill 1.1 }
303    
304     makemodel()
305     {
306     # makemodel directory
307     (
308     cd $1;
309     if test -r Makefile ; then
310     printf 'make ... ' 1>&2
311 edhill 1.24 if test "x$ADM" = x ; then
312 edhill 1.43 if test "x$JOBS" = x ; then
313     $MAKE >> make.log 2>&1
314     else
315     $MAKE -j $JOBS >> make.log 2>&1
316     fi
317 edhill 1.24 else
318     $MAKE adall >> make.log 2>&1
319     fi
320 edhill 1.1 RETVAL=$?
321     if test "x$RETVAL" != x0 ; then
322     tail make.log
323     echo failed 1>&2
324     cp make.log $CDIR"/make.log"
325     return 1
326     else
327 edhill 1.20 echo successful 1>&2
328 edhill 1.1 fi
329     fi
330     )
331     }
332    
333 edhill 1.27 symlink_mpifiles()
334     {
335     # Put special links so that MPI specific files are used
336     # This MUST be invoked between makeclean and makelinks because
337     # the Makefile will link to non-mpi files by default
338    
339     dir=$1
340     code_dir=$2
341     BUILD_DIR=$dir/$3
342     CODE_DIR=$dir/$code_dir
343 edhill 1.45
344 edhill 1.27 # These are files that should replace their counter-part when using -mpi
345     MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi")`
346    
347     # Is this an MPI run?
348     if test "x$MPI" = xt ; then
349     # YES: We symbolically link these files to the build
350     # dir so long as there is no real file in place
351     for ii in $MPI_FILES ; do
352     i=`echo $ii | sed 's:^\./::'`
353     name=`echo $i | sed 's:_mpi::' `
354     cmp $CODE_DIR/$i $BUILD_DIR/$name > /dev/null 2>&1
355     RETVAL=$?
356     if test "x$RETVAL" != x0 ; then
357     if ! test -f $BUILD_DIR/$i ; then
358 edhill 1.45 #echo Linking $name to $i
359 edhill 1.27 (cd $BUILD_DIR; ln -sf ../$code_dir/$i $name)
360     fi
361     fi
362     done
363     else
364 edhill 1.45 # NO: We undo any _mpi symbolically linked files
365 edhill 1.27 for ii in $MPI_FILES ; do
366     i=`echo $ii | sed 's:^\./::'`
367     name=`echo $i | sed 's:_mpi::' `
368     if test -L $BUILD_DIR/$name ; then
369 edhill 1.45 cmp $BUILD_DIR/$name "../$code_dir/$name"_mpi > /dev/null 2>&1
370     RETVAL=$?
371     if test "x$RETVAL" = x0 ; then
372     #echo Un-linking $name from $linktarg
373 edhill 1.27 rm -f $BUILD_DIR/$name
374     fi
375     fi
376     done
377     fi
378    
379     }
380    
381 edhill 1.1 linkdata()
382     {
383     # linkdata flag
384     #
385     # symbolically link data files to run directory
386 edhill 1.12 if test "x$1" = x1 ; then
387     (
388     cd $2
389 edhill 1.24 if test "x$ADM" = x ; then
390     files=`( cd ../input ; ls -1 | grep -v CVS )`
391     for i in $files ; do
392     if test ! -d "../input/"$i ; then
393     ln -sf "../input/"$i $i
394     fi
395     done
396     else
397     files=`( cd ../input ; ls -1 *.bin | grep -v CVS )`
398     for i in $files ; do
399     if test ! -d "../input/"$i ; then
400     ln -sf "../input/"$i $i
401     fi
402     done
403     files=`( cd ../input_ad ; ls -1 | grep -v CVS )`
404     for i in $files ; do
405     if test ! -d "../input_ad/"$i ; then
406     ln -sf "../input_ad/"$i $i
407     fi
408     done
409     fi
410 edhill 1.12 )
411 edhill 1.1 fi
412     }
413    
414     runmodel()
415     {
416 edhill 1.6 # runmodel directory
417 edhill 1.1 #
418 edhill 1.24 # runs "$COMMAND in "directory"
419 edhill 1.6 # (where "$COMMAND" is relative to "directory")
420 edhill 1.1 (
421     cd $1
422 edhill 1.20 printf 'runmodel ... ' 1>&2
423 edhill 1.6 # make output.txt
424 edhill 1.38 echo
425 jmc 1.46 rm -f run.log
426 edhill 1.39 # echo "COMMAND='$COMMAND'"
427     # echo "pwd='"`pwd`"'"
428 jmc 1.46 ( eval $COMMAND ) > run.log 2>&1
429 edhill 1.6 RETVAL=$?
430     if test "x$RETVAL" = x0 ; then
431 jmc 1.46 tail run.log
432 edhill 1.20 echo successful 1>&2
433 edhill 1.44 # === Reduce the size of the testing emails!
434     # if test "x$ADM" = x ; then
435     # cp output.txt $CDIR"/output.txt"
436     # else
437     # cp output.txt_adm $CDIR"/output.txt_adm"
438     # fi
439 jmc 1.48 if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
440 edhill 1.6 return 0
441     else
442 edhill 1.20 tail run.log
443     echo failed 1>&2
444     cp run.log $CDIR"/run.log"
445 jmc 1.48 if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
446 edhill 1.6 return 1
447 edhill 1.1 fi
448     )
449     }
450    
451     createcodelet()
452     {
453     # create codelet for comparing model output
454    
455 edhill 1.34 printf "creating the comparison code... "
456 edhill 1.22 cat > tmp_cmpnum.c <<EOF
457     #include <stdio.h>
458     #include <math.h>
459     int main( int argc, char** argv ) {
460 adcroft 1.33 int linnum,best,lncnt;
461 edhill 1.22 double a,b,diff;
462     best = -16;
463 adcroft 1.33 lncnt = 0;
464     while( 1 & (lncnt+=1) < 999 ) {
465 edhill 1.22 scanf("%d", &linnum);
466     if (linnum == -1) break;
467     scanf("%lf", &a); scanf("%lf", &b);
468     diff = 0.5*(fabs(a)+fabs(b));
469     if (diff > 1.e-12) {
470     diff=fabs(a-b)/diff;
471     if (diff > 0.0) {
472     linnum = (int)log10(diff);
473     best = (best > linnum) ? best : linnum;
474     }
475     else {
476     if (best == -16 && diff != 0) best = -22;
477     }
478     }
479     }
480 adcroft 1.33 if (lncnt == 999) best=-29;
481 edhill 1.22 printf("%d\n", -best);
482     return 0;
483     }
484     EOF
485     cc -o tmp_cmpnum tmp_cmpnum.c -lm
486 edhill 1.1
487 edhill 1.22 if [ -x ./tmp_cmpnum ]; then
488 edhill 1.1 echo "OK"
489     return 0
490     else
491     echo
492 edhill 1.21 echo "ERROR: failed to compile comparison code"
493 edhill 1.1 exit 1
494     fi
495     }
496    
497     formatresults()
498     {
499     # formatresults expt genmake depend make run results*
500    
501     nm=$1
502     printf '%s %s %s %s' $2 $3 $4 $5
503     shift; shift; shift; shift; shift;
504     printf '%3s' $@
505    
506     if [ $1 = '--' ]; then
507     printf ' N/O '
508     else
509     if [ $1 -gt 12 ]; then
510     printf ' pass'
511     else
512     printf ' FAIL'
513     fi
514     fi
515     printf ' %s' $nm
516     printf '\n'
517    
518     }
519    
520     show_help()
521     {
522     cat - << EOF
523     $0 [-help] [-quick] [-verbose] dir1 [dir2] [...]
524 edhill 1.10
525     -help|-h Show this help message
526 edhill 1.1 -quiet Reduce the amount of output
527     -verbose Produce copious amounts of output
528     -debug Produce even more output which will mean nothing to most
529     -force Do "make CLEAN" before compiling. This forces a complete rebuild.
530     -clean Do "make CLEAN" after compiling and testing.
531     -cleanup Aggresively removes all model output, executables and object files
532     and then exits. Use with care.
533    
534     Normal usage:
535     $0 * Configure, compile, run and analyze in all experiment directories
536     EOF
537     }
538    
539     scandirs()
540     {
541     if [ $# -eq 0 ]; then
542     for arg in * ; do
543     test -d $arg/input && echo $arg
544     done
545     else
546     echo $*
547     fi
548     }
549    
550    
551     ###############################################################################
552    
553    
554     # Default properties
555     debug=0
556     verbose=1
557     clean=0
558     expts=''
559 edhill 1.6 # ieee=1
560 edhill 1.10
561 edhill 1.40 IEEE=true
562 edhill 1.10 if test "x$MITGCM_IEEE" != x ; then
563     IEEE=$MITGCM_IEEE
564     fi
565    
566    
567     CLEANUP=f
568     QUICK=f
569     NOGENMAKE=f
570     NOCLEAN=f
571     NODEPEND=f
572 edhill 1.1
573 edhill 1.4 BASH=
574 edhill 1.10 OPTFILE=NONE
575     ADDRESSES=
576 edhill 1.1 TESTDIRS=
577     MPACKDIR="../tools/mpack-1.6"
578 edhill 1.20 HAVE_MPACK=
579 edhill 1.1 MPACK="$MPACKDIR/mpack"
580 edhill 1.24 COMMAND=
581 edhill 1.8 MAKE=make
582 edhill 1.43 JOBS=
583 edhill 1.7 MPI=f
584 edhill 1.40 DELDIR=
585 edhill 1.1
586 edhill 1.24 ADM=
587    
588 edhill 1.34 printf "parsing options... "
589 edhill 1.1
590     ac_prev=
591     for ac_option ; do
592    
593     # If the previous option needs an argument, assign it.
594     if test -n "$ac_prev"; then
595     eval "$ac_prev=\$ac_option"
596     ac_prev=
597     continue
598     fi
599    
600     ac_optarg=`expr "x$ac_option" : 'x[^=]*=\(.*\)'`
601    
602     case $ac_option in
603    
604     -help | --help | -h | --h)
605     usage ;;
606    
607 edhill 1.2 -optfile | --optfile | -of | --of)
608 edhill 1.10 ac_prev=OPTFILE ;;
609 edhill 1.2 -optfile=* | --optfile=* | -of=* | --of=*)
610 edhill 1.10 OPTFILE=$ac_optarg ;;
611 edhill 1.1
612     -addr | --addr | -a | --a)
613     ac_prev=ADDRESSES ;;
614     -addr=* | --addr=*)
615     ADDRESSES=$ac_optarg ;;
616    
617     -tdir | --tdir | -t | --t)
618     ac_prev=TESTDIRS ;;
619     -tdir=* | --tdir=*)
620     TESTDIRS=$ac_optarg ;;
621 edhill 1.4
622     -bash | --bash | -b | --b)
623     ac_prev=BASH ;;
624     -bash=* | --bash=*)
625     BASH=$ac_optarg ;;
626 edhill 1.5
627 edhill 1.6 -command | --command | -c | --c)
628     ac_prev=COMMAND ;;
629     -command=* | --command=*)
630     COMMAND=$ac_optarg ;;
631 edhill 1.8
632     -make | --make | -m | --m)
633     ac_prev=MAKE ;;
634     -make=* | --make=*)
635     MAKE=$ac_optarg ;;
636 edhill 1.1
637 edhill 1.43 -j) ac_prev=JOBS ;;
638     -j=*) JOBS=$ac_optarg ;;
639    
640 edhill 1.10 -clean | --clean)
641     CLEANUP=t ;;
642    
643     -quick | --quick | -q | --q)
644     QUICK=t ;;
645     -nogenmake | --nogenmake | -ng | --ng)
646     NOGENMAKE=t ;;
647     -noclean | --noclean | -nc | --nc)
648     NOCLEAN=t ;;
649     -nodepend | --nodepend | -nd | --nd)
650     NODEPEND=t ;;
651    
652 edhill 1.18 -mpi) MPI=t ;;
653 edhill 1.10
654 edhill 1.24 -adm | -ad) ADM=t ;;
655    
656 edhill 1.10 -ieee) IEEE=true ;;
657     -noieee) IEEE= ;;
658    
659 edhill 1.1 -verbose) verbose=2 ;;
660     -debug) debug=1 ;;
661     -quiet) verbose=0 ;;
662    
663 edhill 1.40 -deldir | -dd) DELDIR=t ;;
664    
665 edhill 1.1 -*)
666     echo "Error: unrecognized option: "$ac_option
667     usage
668     ;;
669    
670     *)
671     echo "Error: unrecognized argument: "$ac_option
672     usage
673     ;;
674    
675     esac
676    
677     done
678    
679 edhill 1.10 if test "x$QUICK" = xt ; then
680     NOGENMAKE=t
681     NOCLEAN=t
682     NODEPEND=t
683     fi
684    
685 edhill 1.1 if test "x$TESTDIRS" = x ; then
686     TESTDIRS=`scandirs`
687     fi
688    
689 edhill 1.10 if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then
690     OPTFILE=$MITGCM_OF
691     fi
692    
693 edhill 1.24 if test "x$ADM" = xt -a "x$COMMAND" = x ; then
694     COMMAND="./mitgcmuv_ad > output.txt_adm 2>&1"
695     fi
696    
697     if test "x$COMMAND" = x ; then
698 edhill 1.45 COMMAND="$MAKE output.txt"
699 edhill 1.24 fi
700    
701 edhill 1.1 echo "OK"
702    
703     # create the FORTRAN comparison code
704     createcodelet
705    
706     # build the mpack utility
707 edhill 1.31 if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then
708 edhill 1.32 echo "skipping mpack build"
709     else
710 edhill 1.31 build_mpack
711     fi
712 edhill 1.1
713     # Create a uniquely named directory to store results
714     MACH=`hostname`
715 edhill 1.2 UNAMEA=`uname -a`
716 edhill 1.1 DATE=`date +%Y%m%d`
717 edhill 1.25 BASE="tr_"$MACH"_"$DATE"_"
718 edhill 1.1 DNUM=0
719     DRESULTS="$BASE$DNUM"
720     while test -e $DRESULTS ; do
721     DNUM=$(( $DNUM + 1 ))
722     DRESULTS="$BASE$DNUM"
723     done
724     mkdir $DRESULTS
725     RETVAL=$?
726     if test "x$RETVAL" != x0 ; then
727 edhill 1.20 echo "ERROR: Can't create results directory \"./$DRESULTS\""
728 edhill 1.1 exit 1
729     fi
730     SUMMARY="$DRESULTS/summary.txt"
731 edhill 1.34 printf "Start time: " >> $SUMMARY
732 edhill 1.16 start_date=`date`
733 edhill 1.17 echo $start_date > $SUMMARY
734 edhill 1.1
735 edhill 1.11 of_path=
736 edhill 1.10 if test "x$OPTFILE" != xNONE ; then
737     if test -r $OPTFILE ; then
738 edhill 1.11 # get the path
739     path=${OPTFILE%/*}
740     if test "x$path" = x ; then
741     of_path=`pwd`
742     else
743     of_path=`( cd $path > /dev/null 2>&1 ; pwd )`
744     fi
745     file=${OPTFILE##*/}
746     OPTFILE=$of_path/$file
747 edhill 1.21 cp $OPTFILE $DRESULTS
748     echo >> $SUMMARY
749     echo " OPTFILE=$OPTFILE" >> $SUMMARY
750 edhill 1.11 else
751 edhill 1.21 echo | tee $SUMMARY
752     echo "ERROR: can't read OPTFILE=\"$OPTFILE\"" | tee $SUMMARY
753     exit 1
754 edhill 1.10 fi
755 edhill 1.21 else
756     echo >> $SUMMARY
757     echo "No \"OPTFILE\" was explicitly specified by testreport," >> $SUMMARY
758     echo " so the genmake default will be used." >> $SUMMARY
759 edhill 1.10 fi
760     echo
761     echo >> $SUMMARY
762 edhill 1.24 if test "x$ADM" = x ; then
763     cat << EOF | tee -a $SUMMARY
764 edhill 1.21 T S U V
765     G D M c m s m s m s m s
766     E p a R g m m e . m m e . m m e . m m e .
767     N n k u 2 i a a d i a a d i a a d i a a d
768     2 d e n d n x n . n x n . n x n . n x n .
769    
770     EOF
771 edhill 1.24 else
772     echo "ADJOINT=true" >> $SUMMARY
773     echo >> $SUMMARY
774     cat << EOF | tee -a $SUMMARY
775     G D M C G
776     E p a R o r
777     N n k u s a
778     2 d e n t d
779    
780     EOF
781     fi
782 edhill 1.1
783 edhill 1.10 # ...and each test directory...
784     for dir in $TESTDIRS ; do
785    
786     # Cleanup only!
787     if test "x$CLEANUP" = xt ; then
788     if test -r $dir/build/Makefile ; then
789     ( cd $dir/build ; make CLEAN )
790     fi
791     if test -r $dir/input/Makefile ; then
792     ( cd $dir/input ; make CLEAN )
793     fi
794     continue
795 edhill 1.1 fi
796 edhill 1.3
797 edhill 1.10 # Verify that the testdir exists and contains previous
798     # results in the correct location--or skip this directory!
799 edhill 1.24 fout=
800     if test "x$ADM" = x ; then
801     fout=$dir"/results/output.txt"
802     else
803     fout=$dir"/results_ad/output.txt_adm"
804     fi
805     if test ! -r $fout ; then
806     echo "can't read \"$fout\" -- skipping $dir"
807 edhill 1.10 continue
808     fi
809 edhill 1.7
810 edhill 1.12 builddir="input"
811     rundir="input"
812     use_seperate_build=0
813     if test -d $dir/build -a -r $dir/build ; then
814     builddir="build"
815     rundir="build"
816     use_seperate_build=1
817     linkdata $use_seperate_build $dir/$rundir
818 edhill 1.10 fi
819    
820 edhill 1.34 # Check whether there are "extra runs" for this testdir
821     extra_runs=
822     if test "x$ADM" = x -a "x$use_seperate_build" = x1 ; then
823     ex_run_dirs=`( cd $dir ; echo input.* )`
824     echo "ex_run_dirs='$ex_run_dirs'"
825     for exd in $ex_run_dirs ; do
826     name=`echo $exd | sed -e 's/input.//g'`
827     outf="$dir/results/output.txt.$name"
828     if test -f $outf -a -r $outf ; then
829     extra_runs="$extra_runs $name"
830     fi
831     done
832     fi
833    
834 edhill 1.24 if test "x$ADM" = x ; then
835 edhill 1.27 code_dir=code
836 edhill 1.24 CODE_DIR=$dir/code
837     else
838 edhill 1.27 code_dir=code_ad
839 edhill 1.24 CODE_DIR=$dir/code_ad
840     fi
841 edhill 1.10 BUILD_DIR=$dir/$builddir
842 edhill 1.28
843 edhill 1.30 if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
844 edhill 1.28 echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
845     continue
846     fi
847    
848     echo "-------------------------------------------------------------------------------"
849     echo
850     echo "Experiment: $dir"
851     echo
852     unset genmake makedepend make run
853     results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'
854 edhill 1.10
855     # Create an output dir for each OPTFILE/tdir combination
856 edhill 1.20 rel_CDIR=$DRESULTS"/"$dir
857     mkdir $rel_CDIR
858     CDIR=`pwd`"/$rel_CDIR"
859 edhill 1.10
860     if test "x$CLEANUP" = xt ; then
861     makeclean $dir/$builddir
862     else
863 edhill 1.1 genmakemodel $dir/$builddir && genmake=Y \
864     && makeclean $dir/$builddir \
865 edhill 1.27 && symlink_mpifiles $dir $code_dir $builddir \
866 edhill 1.1 && makedependmodel $dir/$builddir && makedepend=Y \
867     && makemodel $dir/$builddir && make=Y \
868 edhill 1.12 && linkdata $use_seperate_build $dir/$rundir \
869     && runmodel $dir/$rundir && run=Y \
870 edhill 1.1 && results=`testoutput $dir $rundir`
871 edhill 1.10 fi
872    
873     echo
874 edhill 1.24 if test "x$ADM" = x ; then
875     fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
876 edhill 1.34 echo
877     echo "$fres" >> $SUMMARY
878     echo "fresults='$fres'" > $CDIR"/summary.txt"
879     echo "MACH='$MACH'" >> $CDIR"/summary.txt"
880     echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
881     echo "DATE='$DATE'" >> $CDIR"/summary.txt"
882     echo "tdir='$dir'" >> $CDIR"/summary.txt"
883    
884 edhill 1.35 OLD_COMMAND=$COMMAND
885     COMMAND="./mitgcmuv > output.txt"
886 edhill 1.34 for ex in $extra_runs ; do
887 jmc 1.42 test -e "$dir/tr_run.$ex" && rm -rf "$dir/tr_run.$ex"
888     mkdir "$dir/tr_run.$ex"
889 edhill 1.36 links=`( cd "$dir/input" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`
890 edhill 1.34 (
891 jmc 1.42 cd "$dir/tr_run.$ex"
892 edhill 1.34 for i in $links; do
893     ln -s ../input/$i $i
894     done
895     )
896 edhill 1.36 links=`( cd "$dir/input.$ex" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`
897 edhill 1.34 (
898 jmc 1.42 cd "$dir/tr_run.$ex"
899 edhill 1.34 for i in $links; do
900     test -e $i && rm -f $i
901     ln -s ../input.$ex/$i $i
902     done
903     ln -s ../$builddir/mitgcmuv mitgcmuv
904     )
905 jmc 1.42 runmodel $dir/tr_run.$ex && run=Y \
906     && results=`testoutput $dir tr_run.$ex "."$ex`
907 edhill 1.34 fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`
908     fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
909     fres="$fres.$ex"
910     echo
911     echo "$fres" >> $SUMMARY
912     echo "fresults='$fres'" > $CDIR"/summary.txt"
913     echo "MACH='$MACH'" >> $CDIR"/summary.txt"
914     echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
915     echo "DATE='$DATE'" >> $CDIR"/summary.txt"
916     echo "tdir='$dir'" >> $CDIR"/summary.txt"
917     done
918 edhill 1.35 COMMAND=$OLD_COMMAND
919 edhill 1.24 else
920     fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`
921     fres=$fres"$results $dir"
922 edhill 1.34 echo
923     echo "$fres" >> $SUMMARY
924     echo "fresults='$fres'" > $CDIR"/summary.txt"
925     echo "MACH='$MACH'" >> $CDIR"/summary.txt"
926     echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
927     echo "DATE='$DATE'" >> $CDIR"/summary.txt"
928     echo "tdir='$dir'" >> $CDIR"/summary.txt"
929 edhill 1.24 fi
930 edhill 1.10
931     echo "-------------------------------------------------------------------------------"
932    
933 edhill 1.1 done
934    
935 edhill 1.34 printf "Start time: " >> $SUMMARY
936 edhill 1.16 echo $start_date >> $SUMMARY
937 edhill 1.34 printf "End time: " >> $SUMMARY
938 edhill 1.13 date >> $SUMMARY
939 edhill 1.20
940     # If addresses were supplied and mpack built successfully, then try
941     # to send email using mpack.
942     if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then
943     echo "No results email was sent."
944     else
945     if test "x$HAVE_MPACK" = xt ; then
946     tar -cf $DRESULTS".tar" $DRESULTS > /dev/null 2>&1 \
947     && gzip $DRESULTS".tar" \
948 edhill 1.44 && $MPACK -s MITgcm-test -m 3555000 $DRESULTS".tar.gz" $ADDRESSES
949 edhill 1.20 RETVAL=$?
950     if test "x$RETVAL" != x0 ; then
951     echo
952     echo "Warning: The tar, gzip, & mpack step failed. Please send email"
953     echo " to <MITgcm-support@mitgcm.org> for help. You may copy the "
954     echo " summary of results from the directory \"$DRESULTS\"."
955     echo
956     else
957     echo
958     echo "An email containing results was sent to the following addresses:"
959     echo " \"$ADDRESSES\""
960     echo
961     fi
962     test -f $DRESULTS".tar" && rm -f $DRESULTS".tar"
963     test -f $DRESULTS".tar.gz" && rm -f $DRESULTS".tar.gz"
964     fi
965     fi
966 edhill 1.13
967 edhill 1.22 # rm -f tmp_cmpnum.f a.out
968     rm -f tmp_cmpnum.c tmp_cmpnum
969 edhill 1.1
970 edhill 1.12 if test "x$CLEANUP" != xt ; then
971     cat $SUMMARY
972 edhill 1.25 if test -e tr_out.txt ; then
973     mv tr_out.txt tr_out.txt.old
974 edhill 1.14 fi
975 edhill 1.25 cat $SUMMARY > tr_out.txt
976 edhill 1.12 fi
977 edhill 1.1
978 edhill 1.40 if test "x$DELDIR" = xt ; then
979     rm -rf $DRESULTS
980     fi
981    

  ViewVC Help
Powered by ViewVC 1.1.22